# 自定义模块
## 1. 概述
Enhancer 支持将常用后端代码块以模块的形式封装，提高系统的复用性和可维护性。定义好的模块可以在任何后台运行的代码中使用，包括`自定义接口`, `事件响应后台过程（JS 过程或者 SQL 前后脚本）`, `其他自定义模块`, `系统启动函数`, `登录前中后校验`。

## 2. 定义模块
在 **工作台->自定义模块** 开发面板中添加一个自定义模块，命名为 my-custom-module：

```javascript
var message = 'Hello world!';

// Node JS 通用模块规范，使用 module.exports 才能将代码导出暴露给外部使用。
module.exports = {  
    getMessage: function() {
        return message;
    }
};

```

#### 定义完毕之后，其他地方使用该模块只需书写 var mod = require('@custom/模块名') 即可。

#### `注意：在测试开发阶段，您必须安装桥(1.4.0 以上)，并在工作台自定义模块定义下方点击【加载到测试环境】模块才能生效！`
#### `注意：自定义模块内不支持直接使用 Enhancer 全局对象和 @变量@，如果有使用，需要自己留出方法传递参数。`

## 3. 使用模块

【例】在表单【提交】按钮事件配置的后台 JS 过程中使用自定义模块：

```javascript

var mod = require('@custom/my-custom-module');

done(null, {
    success: true,
    message: mod.getMessage()
});

```

运行后，点击【提交】按钮，会收到 Hello world! 提示。

